
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define LEN	1024

int	main(int argc,char **argv)
{
	FILE	*file;
	char	str[LEN];
	double	x0,y0,d,D,c,s,b1,b2,a,a1,a2,*x=NULL,*y=NULL;
	int	i,j,I,J,N=0;

	if (argc!=2) {
	    (void)fputs("usage : line2ab file\n",stderr); exit(1);
	}
	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"r"))==NULL) {
		(void)fputs("file not found.\n",stderr); exit(1);
	    }

	while (fgets(str,LEN,file)!=NULL) {
	    if (sscanf(str,"%lf %lf %lf",&x0,&y0,&d)!=2) continue;

	    ++N;
	    if ((x=(double *)realloc(x,sizeof(double)*N))==NULL ||
		(y=(double *)realloc(y,sizeof(double)*N))==NULL) {
		(void)fputs("memory allocation error.\n",stderr); exit(1);
	    }
	    x[N-1]=x0; y[N-1]=y0;
	}
	if (file!=stdin) fclose(file);

	D=0.0;
	for (i=0; i<N-1; i++) for (j=i+1; j<N; j++) {
	    x0=x[i]-x[j]; y0=y[i]-y[j];
	    if ((d=(x0*x0+y0*y0))>D) {
		I=i; J=j; D=d;
	    }
	}
	d=sqrt(D); c=(y[I]-y[J])/d; s=(-(x[I]-x[J]))/d;
	if ((b1=(-s)*x[I]+c*y[I])>(b2=(-s)*x[J]+c*y[J])) {
	    d=b1; b1=b2; b2=d;
	}
	for (i=0; i<N; i++) {
	    a=c*x[i]+s*y[i];
	    if (i==0) a1=a2=a; else if (a<a1) a1=a; else if (a>a2) a2=a;
	}
	(void)printf("%lg\t%lg\n",a2-a1,b2-b1);
	(void)printf("%lg\t%lg\n",a1*c-b1*s,a1*s+b1*c);
	(void)printf("%lg\t%lg\n",a2*c-b1*s,a2*s+b1*c);
	(void)printf("%lg\t%lg\n",a2*c-b2*s,a2*s+b2*c);
	(void)printf("%lg\t%lg\n",a1*c-b2*s,a1*s+b2*c);

	free(y); free(x); return 0;
}
