#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifndef	M_PI
#define M_PI	3.14159265358979323846
#endif

#define LEN	1024

int	main(int argc,char **argv)
{
	FILE	*file;
        char	str[LEN];
	double	x0,y0,d,t,c,s,a,b,a1,a2,b1,b2,C,S,A1,A2,B1,B2,D,
		*x=NULL,*y=NULL,step=1.0;
	int	n,N=0;

	if (argc!=2 && argc!=3) {
	    (void)fputs("usage : line2ab_ls file {step}\n",stderr); exit(1);
	}
	if (argc==3 && (step=atof(argv[2]))<=0.0) {
	    (void)fputs("bad step of angle in degree.\n",stderr); exit(1);
	}
	step*=(M_PI/180.0);

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"r"))==NULL) {
		(void)fputs("file not found.\n",stderr); exit(1);
	    }

	while (fgets(str,LEN,file)!=NULL) {
	    if (sscanf(str,"%lf %lf %lf",&x0,&y0,&d)!=2) continue;

	    n=N++;
            if ((x=(double *)realloc(x,sizeof(double)*N))==NULL ||
		(y=(double *)realloc(y,sizeof(double)*N))==NULL) {
		(void)fputs("memory allocation error.\n",stderr); exit(1);
	    }
	    x[n]=x0; y[n]=y0;
	}
	if (file!=stdin) fclose(file);

	for (t=0.0; t<M_PI; t+=step) {
	    c=cos(t); s=sin(t);
	    for (n=0; n<N; n++) {
		a=x[n]*c+y[n]*s; b=y[n]*c-x[n]*s;
		if (n==0) {
		    a1=a2=a; b1=b2=b;
		}
		else {
		    if (a<a1) a1=a; if (a>a2) a2=a;
		    if (b<b1) b1=b; if (b>b2) b2=b;
		}
	    }
	    if (t<step/2.0) {
		C=c; S=s; A1=a1; A2=a2; D=(B2=b2)-(B1=b1);
	    }
	    else if ((d=b2-b1)>D) {
		C=c; S=s; D=d; A1=a1; A2=a2; B1=b1; B2=b2;
	    }
	}
	(void)printf("%lg\t%lg\n",A2-A1,B2-B1);
	(void)printf("%lg\t%lg\n",C*A1-S*B1,S*A1+C*B1);
	(void)printf("%lg\t%lg\n",C*A2-S*B1,S*A2+C*B1);
	(void)printf("%lg\t%lg\n",C*A2-S*B2,S*A2+C*B2);
	(void)printf("%lg\t%lg\n",C*A1-S*B2,S*A1+C*B2);

	free(y); free(x); return 0;
}
