
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define LEN	1024

int	main(int argc,char **argv)
{
	FILE	*file;
	char	str[LEN];
	double	x0,y0,z0,d,D,l,cl,sl,p,cp,sp,cx,cy,cz,c1,c2,
		t,ct,st,bx,by,bz,b1,b2,ax,ay,az,a,a1,a2,
		*x=NULL,*y=NULL,*z=NULL;
	int	i,j,I,J,N=0;

	if (argc!=2) {
	    (void)fputs("usage : zcp2abc file\n",stderr); exit(1);
	}
	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"r"))==NULL) {
		(void)fputs("file not found.\n",stderr); exit(1);
	    }

	while (fgets(str,LEN,file)!=NULL) {
	    if (sscanf(str,"%lf %lf %lf %lf",&x0,&y0,&z0,&d)!=3) continue;

	    ++N;
	    if ((x=(double *)realloc(x,sizeof(double)*N))==NULL ||
		(y=(double *)realloc(y,sizeof(double)*N))==NULL ||
		(z=(double *)realloc(z,sizeof(double)*N))==NULL) {
		(void)fputs("memory allocation error.\n",stderr); exit(1);
	    }
	    x[N-1]=x0; y[N-1]=y0; z[N-1]=z0;
	}
	if (file!=stdin) fclose(file);

	D=0.0;
	for (i=0; i<N-1; i++) for (j=i+1; j<N; j++) {
	    x0=x[i]-x[j]; y0=y[i]-y[j]; z0=z[i]-z[j];
	    if ((d=x0*x0+y0*y0+z0*z0)>D) {
		I=i; J=j; D=d;
	    }
	}
	l=atan2(y0=y[I]-y[J],x0=x[I]-x[J]); cl=cos(l); sl=sin(l);
	p=atan2(z[I]-z[J],sqrt(x0*x0+y0*y0)); cp=cos(p); sp=sin(p);
	cx=cl*cp; cy=sl*cp; cz=sp;
	if ((c1=cx*x[I]+cy*y[I]+cz*z[I])>(c2=cx*x[J]+cy*y[J]+cz*z[J])) {
	    d=c1; c1=c2; c2=d;
	}
	D=0.0;
	for (i=0; i<N-1; i++) for (j=i+1; j<N; j++) {
	    x0=x[i]-x[j]; y0=y[i]-y[j]; z0=z[i]-z[j]; d=cx*x0+cy*y0+cz*z0;
	    if ((d=x0*x0+y0*y0+z0*z0-d*d)>D) {
		I=i; J=j; D=d;
	    }
	}
	x0=x[I]-x[J]; y0=y[I]-y[J];
	t=atan2(x0*sl-y0*cl,(z[I]-z[J])*cp-(x0*cl+y0*sl)*sp);
	ct=cos(t); st=sin(t);
	bx=(-sl)*st+cl*sp*ct; by=cl*st+sl*sp*ct; bz=(-cp)*ct;
	if ((b1=bx*x[I]+by*y[I]+bz*z[I])>(b2=bx*x[J]+by*y[J]+bz*z[J])) {
	    d=b1; b1=b2; b2=d;
	}
	ax=sl*ct+cl*sp*st; ay=(-cl)*ct+sl*sp*st; az=(-cp)*st;
	for (i=0; i<N; i++) {
	    a=ax*x[i]+ay*y[i]+az*z[i];
	    if (i==0) a1=a2=a; else if (a<a1) a1=a; else if (a>a2) a2=a;
	}
	(void)printf("%lg\t%lg\t%lg\n",a2-a1,b2-b1,c2-c1);

#define X(A,B,C)	A*ax+B*bx+C*cx
#define Y(A,B,C)	A*ay+B*by+C*cy
#define Z(A,B,C)	A*az+B*bz+C*cz

	(void)printf("%lg\t%lg\t%lg\n",X(a1,b1,c1),Y(a1,b1,c1),Z(a1,b1,c1));
	(void)printf("%lg\t%lg\t%lg\n",X(a2,b1,c1),Y(a2,b1,c1),Z(a2,b1,c1));
	(void)printf("%lg\t%lg\t%lg\n",X(a2,b2,c1),Y(a2,b2,c1),Z(a2,b2,c1));
	(void)printf("%lg\t%lg\t%lg\n",X(a1,b2,c1),Y(a1,b2,c1),Z(a1,b2,c1));
	(void)printf("%lg\t%lg\t%lg\n",X(a1,b1,c2),Y(a1,b1,c2),Z(a1,b1,c2));
	(void)printf("%lg\t%lg\t%lg\n",X(a2,b1,c2),Y(a2,b1,c2),Z(a2,b1,c2));
	(void)printf("%lg\t%lg\t%lg\n",X(a2,b2,c2),Y(a2,b2,c2),Z(a2,b2,c2));
	(void)printf("%lg\t%lg\t%lg\n",X(a1,b2,c2),Y(a1,b2,c2),Z(a1,b2,c2));

	free(z); free(y); free(x); return 0;
}
