BEGIN {
  Rad=atan2(1,1)/45
  N=0
  if (Ml==0) Ml=360
  if (Mp==0) Mp=180
  if (Mt==0) Mt=180
}
NF==3 { x[N]=$1; y[N]=$2; z[N]=$3; ++N }
END {
  for (ml=0; ml<Ml; ml++) {
    l=Rad*360*ml/Ml; cl=cos(l); sl=sin(l)
    for (mp=0; mp<Mp; mp++) {
      p=Rad*(180*mp/Mp-90); cp=cos(p); sp=sin(p)
      cx=cl*cp; cy=sl*cp; cz=sp
      for (n=0; n<N; n++) {
        c=cx*x[n]+cy*y[n]+cz*z[n]
        if (n==0) c1=c2=c; else if (c<c1) c1=c; else if (c>c2) c2=c
      }
      if (ml==0 && mp==0) {
        Cl=cl; Sl=sl; Cp=cp; Sp=sp; Cx=cx; Cy=cy; Cz=cz; D=(C2=c2)-(C1=c1)
      }
      else if ((d=c2-c1)>D) {
        Cl=cl; Sl=sl; Cp=cp; Sp=sp; Cx=cx; Cy=cy; Cz=cz; D=d; C1=c1; C2=c2
      }
    }
  }
  for (mt=0; mt<Mt; mt++) {
    t=Rad*180*mt/Mt; ct=cos(t); st=sin(t)
    bx=(-Sl)*st+Cl*Sp*ct; by=Cl*st+Sl*Sp*ct; bz=(-Cp)*ct
    for (n=0; n<N; n++) {
      b=bx*x[n]+by*y[n]+bz*z[n]
      if (n==0) b1=b2=b; else if (b<b1) b1=b; else if (b>b2) b2=b
    }
    if (mt==0) {
      Ct=ct; St=st; Bx=bx; By=by; Bz=bz; D=(B2=b2)-(B1=b1)
    }
    else if ((d=b2-b1)<D) {
      Ct=ct; St=st; Bx=bx; By=by; Bz=bz; D=d; B1=b1; B2=b2
    }
  }
  Ax=Sl*Ct+Cl*Sp*St; Ay=(-Cl)*Ct+Sl*Sp*St; Az=(-Cp)*St
  for (n=0; n<N; n++) {
    a=Ax*x[n]+Ay*y[n]+Az*z[n]
    if (n==0) A1=A2=a; else if (a<A1) A1=a; else if (a>A2) A2=a
  }
  printf "%g\t%g\t%g\n",B2-B1,A2-A1,C2-C1
  printf "%g\t%g\t%g\n",A1*Ax+B1*Bx+C1*Cx,A1*Ay+B1*By+C1*Cy,A1*Az+B1*Bz+C1*Cz
  printf "%g\t%g\t%g\n",A2*Ax+B1*Bx+C1*Cx,A2*Ay+B1*By+C1*Cy,A2*Az+B1*Bz+C1*Cz
  printf "%g\t%g\t%g\n",A2*Ax+B2*Bx+C1*Cx,A2*Ay+B2*By+C1*Cy,A2*Az+B2*Bz+C1*Cz
  printf "%g\t%g\t%g\n",A1*Ax+B2*Bx+C1*Cx,A1*Ay+B2*By+C1*Cy,A1*Az+B2*Bz+C1*Cz
  printf "%g\t%g\t%g\n",A1*Ax+B1*Bx+C2*Cx,A1*Ay+B1*By+C2*Cy,A1*Az+B1*Bz+C2*Cz
  printf "%g\t%g\t%g\n",A2*Ax+B1*Bx+C2*Cx,A2*Ay+B1*By+C2*Cy,A2*Az+B1*Bz+C2*Cz
  printf "%g\t%g\t%g\n",A2*Ax+B2*Bx+C2*Cx,A2*Ay+B2*By+C2*Cy,A2*Az+B2*Bz+C2*Cz
  printf "%g\t%g\t%g\n",A1*Ax+B2*Bx+C2*Cx,A1*Ay+B2*By+C2*Cy,A1*Az+B2*Bz+C2*Cz
}
